<?php
/**
 * Magento
 *
 * NOTICE OF LICENSE
 *
 * @category     :  ModuleBank
 * @package      :  ModuleBank_ICCardPayment
 *
 * @company      :  ModuleBank
 * @created by   :  Seyed Hamzeh Fazeli
 * @contact      :  www.ModuleBank.ir, support@modulebank.ir, 09160666110
 * @created on   :  August 2020
 * @copyright    :  Copyright (C) 2020. All rights reserved.
 * @author       :  Seyed Hamzeh Fazeli
 * @description  :  ICCard Gateway Payment for the component (Magento)
 */
class ModuleBank_Iccard_Block_Redirect extends Mage_Core_Block_Template
{
    /**
     * Return checkout session instance
     *
     * @return Mage_Checkout_Model_Session
     */
    protected function _getCheckout()
    {
        return Mage::getSingleton('checkout/session');
    }

    /**
     * Return order instance
     *
     * @return Mage_Sales_Model_Order|null
     */
    protected function _getOrder()
    {
        if ($this->getOrder()) {
            return $this->getOrder();
        } elseif ($orderIncrementId = $this->_getCheckout()->getLastRealOrderId()) {
            return Mage::getModel('sales/order')->loadByIncrementId($orderIncrementId);
        } else {
            return null;
        }
    }

	public function getFormData()
	{
		$order = $this->_getOrder()->_data;
		require_once(dirname(dirname(__FILE__)) . '/iccard_payment_helper.class.php');
		$i = new ICCard_Payment_Helper($this->_getOrder()->getPayment()->getMethodInstance()->getConfigData('terminal'));
		$r = $i->paymentRequest(array(
				'amount'      => intval(ceil($order["grand_total"])),
				'order_id'    => $order["entity_id"],
				'description' => $order['increment_id'],
			));
		if ($r)
		{
			return array(1, $i->token);
		}
		else
		{
			return array(0, $i->error);
		}
    }
}
